$segmented
$model(medium)
$extend
$nomod166
$stdnames(reg164ci.def)
$NOLOCALS

	regdef	R14,R13,R12,R4,R1
;**************************************************************************************************************

; Definition des OS-Routinen
OSsegment	EQU	0
POP_R4		EQU	0765AH
PUSH_R12	EQU	075D6H

userseg		SECTION CODE word at 3D000h
assume	dpp3:userseg


;************************************************************************************************************


sh_out	proc  near
	;Data (16Bit) in R12 !!
	PUSH	R12

	MOV	R13,#00h
_3:     ;for i=0 ... 15
	MOV	R14,R12
	ASHR	R14,#0Fh
	BMOVN	USR0,Z
	BMOV	CC62IO,USR0
	SHL	R12,#01h
	BSET	COUT62
	BCLR	COUT62
	CMPI1	R13,#0Fh
	JMPR	cc_SLT,_3 ; next for; jump if R13 < 0x0F

	BSET	CTRAP ; Strobe-Clock
	BCLR	CTRAP

	POP	R12
	RETN
sh_out	endp


getData	proc near
	CALLS	OSsegment,POP_R4	;hole Daten vom Stack
	PUSH	R4
	CALLS  	OSsegment,POP_R4	;hole Ports vom Stack
	SHL	R4, #10
	POP	R12
	RETN			       
getData	endp


char	proc near ;Zeichen senden
	AND	R12,#000FFh
	OR	R12,R4
	OR	R12,#00300h ;RS true, En true
	CALLR	sh_out
	AND	R12,#0FDFFh ;RS true, En false
	CALLR	sh_out
	RETN
char	endp

_cmd	proc near ;Kommando senden

	AND	R12,#000FFh
	OR	R12,R4
	OR	R12,#00200h ;RS false, En true
	CALLR	sh_out
	AND	R12,#0FDFFh ;RS false, En false
	CALLR	sh_out

	RETN
_cmd	endp


put	proc far
	CALLR	getData

	CALLR	char

 	POP	R1 
	POP	R1
	RETS	   
put	endp

_prnlen	proc near
_4:
	PUSH	R13
	EXTS	#8,#1
	MOV	R12,[R1]
	CALLR	char
	POP	R13
	CMPD1	R13,#1
	JMPR	cc_SLE,_5 

	PUSH	R13
	EXTS	#8,#1
	MOV	R12,[R1]
	SHR	R12,#8
	CALLR	char

	ADD	R1,#2
	POP	R13
	CMPD1	R13,#1
	JMPR	cc_SGT,_4
_5:
	RETN
_prnlen	endp
	
print	proc far
	CALLR	getData
	MOV	R1,R12
	ADD	R12,#30
	EXTS	#8,#1
	MOV	R13,[R12]
	SHR	R13,#8
	
	CALLR	_prnlen

 	POP	R1 
	POP	R1
	RETS	   
print	endp
	
send	proc far
	CALLS	OSsegment,POP_R4	;hole Puffergre vom Stack
	MOV	R13,R4
	CALLR	getData
	MOV	R1,R12
	
	CALLR	_prnlen

 	POP	R1	
	POP	R1
	RETS		
send	endp
	

cmd	proc far
	CALLR	getData
	CALLR	_cmd
 	POP	R1	
	POP	R1
	RETS		
cmd	endp
	
ports	proc far ;Ports senden
	CALLS  	OSsegment,POP_R4	;hole Ports vom Stack
	SHL	R4, #10
	MOV	R12,R4

	CALLR	sh_out
 	
 	POP	R1	
	POP	R1
	RETS
ports	endp

userseg	ENDS
	END
